openapi: 3.0.0
info:
  title: Node API Backend Test
  description: This is a Node.js Express Backend API for Get Email records and add new email
  version: 0.0.1
servers:
  - url: http://localhost:3002 
    description: Default Local server for development purposes
paths:
  /email:
    post:
      summary: Post an Email Record
      description: This is used to add new email record
      requestBody:
        content:
          application/json:
            schema:
              $ref: "#/components/schemas/EmailRequest"
      responses:
        "200":
          description: This endpoint returned HTTP code 200 if the record successfuly addded to data storage
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/EmailResponse"
              example:
                id: 1
                name: "Rizky"
                email: "rizky@test.com"
                status: True
        "400":
          description: Invalid Email Value
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/EmailErrorResponse"
              example:
                status: False
                email: "test@email.com"
                message: "is invalid"
        "409":
          description: Duplicate Email Value
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/EmailErrorResponse"
              example:
                status: False
                email: "test@email.com"
                message: "Email has already been used"
        "500":
          description: Internal Server Error Happened
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/GeneralErrorResponse"
              example:
                status: True
                message: "Something wrong happened"
               
    get:
      summary: Get all Email Records
      description: This is used to get all email records
      responses:
        "201":
          description: Return an array of email records and status
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/EmailListResponse"
              example:
                    status: True
                    data:
                       -  id: 1
                          name: "Rizky"
                          email: "rizky@test.com"
                          status: True
        "500":
          description: Internal Server Error Happened
          content:
            application/json:
              schema:
                $ref: "#/components/schemas/GeneralErrorResponse"
              example:
                status: True
                message: "Something wrong happened"
 
components:
  schemas:
    EmailRequest:
      type: object
      properties:
        email:
          type: string
          example: "test@email.com"
        name:
          type: string
          example: "test"
      required:
        - email
        - name
    EmailResponse:
      type: object
      properties:
        id:
          type: integer
          example: 1
        email:
          type: string
          example: "test@email.com"
        name:
          type: string
          example: "test"
    EmailListResponse:
      type: object
      properties:
        status:
          type: Boolean
          example: True
        data:
          type: array
          items:
            $ref: "#/components/schemas/EmailResponse"
    EmailErrorResponse:
      type: object
      properties:
        email:
          type: string
          example: "test@email.com"
        status:
          type: Boolean
          example: False
        message:
          type: string
          example: "Something went wrong"
    GeneralErrorResponse:
      type: object
      properties:
        status:
          type: Boolean
          example: False
        message:
          type: string
          example: "Something went wrong"